nucleo_uniforme<-function(x){
 apply(x,2,function(x){ifelse(abs(x)<1,1/2,0)})
}

est_nucleo<-function(x,h,muestra,nucleo){
 apply(nucleo(outer(x,muestra,"-")/h),1,"mean")*(1/h)
}


#---- Muestra
n<-100
muestra<-rnorm(n)
h<-0.2



#-- Para una secuencia
x<-seq(-3,3,by=0.01)
sol<-est_nucleo(x,h,muestra,nucleo_uniforme)


#---- Pintamos el resultado
windows()
plot(sol~x,type="l",col=4,lwd=2,main="Naive")
lines(dnorm(x)~x,col=2)
